package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;

/**
 * @Description : WmsECartOrderNoBuild
 * @Author :gsz
 * @Date 2021/7/5 19:06
 * @Modify
 **/
@Data
@Entity
@Table(name="WMS_ECARD_ORDERNO_BUILD")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Api(value="南非看板订单号",description = "南非看板订单号")
public class WmsECartOrderNoBuild extends BaseBean {

    private static final long serialVersionUID = 7332606009041273554L;
    @Column(name = "PART_NO")
    @ApiParam(value = "物料代码")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private String partNo;

    @Column(name = "CREATE_DATE")
    @ApiParam(value = "创建日期")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private String creatDate;

    @Column(name = "SERIAL_NO")
    @ApiParam(value = "序列号")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.NUMBER)
    private Integer serialNo;

    @Column(name = "DEST_LOCATE_NO")
    @ApiParam(value = "目标库位")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private Integer destLocateNo;

    @Column(name = "SRC_ZONE_NO")
    @ApiParam(value = "源存储区")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private Integer srcZoneNo;

    public Integer getUnitPrecisionValue(){
        return this.serialNo == null?0:this.serialNo.intValue();
    }

    public WmsECartOrderNoBuild(String partNo, String creatDate, Integer serialNo) {
        this.partNo = partNo;
        this.creatDate = creatDate;
        this.serialNo = serialNo;
    }

    public WmsECartOrderNoBuild(String partNo, String creatDate, Integer serialNo, Integer destLocateNo, Integer srcZoneNo) {
        this.partNo = partNo;
        this.creatDate = creatDate;
        this.serialNo = serialNo;
        this.destLocateNo = destLocateNo;
        this.srcZoneNo = srcZoneNo;
    }
}